unless window.requestAnimationFrame?
  window.requestAnimationFrame =
    window.webkitRequestAnimationFrame or window.mozRequestAnimationFrame

# Almost the same as quat4.toMat4()
quat4.toMatrix = (quat, dest) ->
  dest = mat4.create() unless dest

  x = quat[0]
  y = quat[1]
  z = quat[2]
  w = quat[3]

  x2 = x + x
  y2 = y + y
  z2 = z + z

  xx = x * x2
  xy = x * y2
  xz = x * z2
  yy = y * y2
  yz = y * z2
  zz = z * z2
  wx = w * x2
  wy = w * y2
  wz = w * z2

  dest[0] = 1 - (yy + zz)
  dest[1] = xy - wz
  dest[2] = xz + wy

  dest[4] = xy + wz
  dest[5] = 1 - (xx + zz)
  dest[6] = yz - wx

  dest[8] = xz - wy
  dest[9] = yz + wx
  dest[10] = 1 - (xx + yy)

  dest

mat4.toQuaternion = (mat, dest) ->
  dest = quat4.create() unless dest

  copysign = (x, y) ->
    if y < 0 then -Math.abs(x) else Math.abs(x)

  dest[0] = Math.sqrt(Math.max(0, 1 + mat[0] - mat[5] - mat[10])) / 2
  dest[1] = Math.sqrt(Math.max(0, 1 - mat[0] + mat[5] - mat[10])) / 2
  dest[2] = Math.sqrt(Math.max(0, 1 - mat[0] - mat[5] + mat[10])) / 2
  dest[3] = Math.sqrt(Math.max(0, 1 + mat[0] + mat[5] + mat[10])) / 2

  dest[0] = copysign(dest[0], (mat[9] - mat[6]))
  dest[1] = copysign(dest[1], (mat[2] - mat[8]))
  dest[2] = copysign(dest[2], (mat[4] - mat[1]))

  quat4.normalize(dest)
