window.onload = ->
  canvas = document.getElementById('stage')
  viewport = {width: window.innerWidth, height: window.innerHeight}

  canvas.setAttribute('width', viewport.width)
  canvas.setAttribute('height', viewport.height)

  gl = canvas.getContext('experimental-webgl')

  unless gl
    alert('Could not initialize WebGL')
    return

  input = new Input()
  rendering = new Rendering(gl, viewport, input)

  startGameLoop(gl, rendering)

  window.addEventListener 'keyup', ((event) -> input.onKeyUp(event)), false
  window.addEventListener 'keydown', ((event) -> input.onKeyDown(event)), false
  window.addEventListener 'mousemove', ((event) -> input.onMouseMove(event)), false

startGameLoop = (gl, rendering) ->
  tick = (time) ->
    window.requestAnimationFrame(tick)
    rendering.draw(gl, time)

  window.requestAnimationFrame(tick)
